package  
{

	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
		import flash.geom.Point;
	import net.flashpunk.graphics.*
		import net.flashpunk.graphics.Image;
	import net.flashpunk.tweens.misc.NumTween;
	import net.flashpunk.tweens.motion.LinearMotion;
	import net.flashpunk.utils.Ease;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.*;
	import com.greensock.easing.*
	import com.greensock.TweenMax;		
	import GameWorld;
	import Player;
	import flash.utils.getTimer;
	import GC;
	
	/**
	 * ...
	 * @author Seth
	 */
	public class Bullet extends Moveable
	{
			public var image:Spritemap = null;
			public var speed = 100;
			public var vTarget = new Point(1, 0);
			public var deathTimer:int = getTimer() + 10000;
			public function Bullet() 
		{
			image = new Spritemap(GC.GFX_BULLET, 16, 16);
			image.add("fly", [0, 1, 2, 3], 20, true);
			image.play("fly");
		
			graphic = image;
			type = "bullet";
			setHitbox(image.width * 0.7, image.height * 0.7);
		}

		override protected function collideX(e:Entity):void 
		{
				trace("Bullet hit X");
		}
		
		/**
		 * Vertical collision (override for specific behaviour).
		 */
		override protected function collideY(e:Entity):void 
		{
				trace("Bullet hit Y");
		}
		
		public function SetOwner(owner:Entity)
		{
			if (owner.type = "player")
			{
				type = "pbullet";
				speed = 600;
			}
			
			(FP.world as GameWorld).ScheduleSound(0, GC.SFX_SPIT);

		}
		public function SetAim(tx:Number, ty:Number)
		{
			vTarget.x = tx - x;
			vTarget.y = ty - y;
			vTarget.normalize(1);
		}
		
			function IsOnScreen()
		{
			var temp:Number = (FP.world.camera.x + FP.halfWidth) - x;
			if (Math.abs(temp) < FP.halfWidth) return true;
			
			return false;
		}
		
			override public function update():void
			{
				//move(1*FP.elapsed, 1*FP.elapsed);
				x += vTarget.x * speed * FP.elapsed;
				y += vTarget.y * speed * FP.elapsed;
				
				if (deathTimer < getTimer() || !IsOnScreen())
				{
					FP.world.remove(this);
				}
				
			}
	
		
	}

}