package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Emitter;
	import net.flashpunk.graphics.ParticleType;
	import net.flashpunk.utils.Ease;
	
	public class Particles extends Entity
	{
		/**
		 * Particle emitter.
		 */
		[Embed(source = '../assets/particle.png')] private const PARTICLE:Class;
		public var emitter:Emitter = new Emitter(PARTICLE, 11, 11);
		
		/**
		 * Constructor, define particles and stuff.
		 */
		public function Particles() 
		{
			graphic = emitter;
			emitter.x = emitter.y = -5;
			layer = 1;
			
			var p:ParticleType = emitter.newType("dust", [11, 12, 13, 14]);
			p.setMotion(20, 5, .2, 140, 50, .3, Ease.cubeOut);
			p.setColor(0xFF4444, 0xFF4444, Ease.quadIn);
			
			p = emitter.newType("trail", [14]);
			p.setMotion(270-40, 80, .5, 40*2, 30, .5);
			p.setColor(0xFF3366, 0xFF3366);
			
			p.setAlpha(1, 0);
			
		}
	}
}