package  
{
	import flash.display.InteractiveObject;
	import Bullet;
	import net.flashpunk.graphics.Image;
	import flash.utils.getTimer;
	import net.flashpunk.*;
	
 /**
	 * ...
	 * @author Seth
	 */
	
	public class Turret extends Moveable
	{
		public var image:Image = null;
		public var shootTimer:int;
		
		public function Turret(enemyType:String) 
		{
			if (enemyType == "boss")
			{
			image = new Image(GC.GFX_WITCH);
				
			} else
			{
			image = new Image(GC.GFX_TURRET);
				
			}
			graphic = image;
			type = "damage";

			var hitBoxModX:Number = 0.7;
			var hitBoxModY:Number = 0.7;

			setHitbox(image.width *  hitBoxModX, image.height *hitBoxModY);
			shootTimer = getTimer() + Math.random() * 2000;
					setOrigin( ((image.width * hitBoxModX) -(image.width )) / 2,
			((image.height * hitBoxModY) -(image.height)) / 2);
	
		}
		
		function IsOnScreen()
		{
			var temp:Number = (FP.world.camera.x + FP.halfWidth) - x;
			if (Math.abs(temp) < FP.halfWidth) return true;
			
			return false;
		}
		
		
		public function OnExplode():void
		{
			(FP.world as GameWorld).ScheduleSound(0, GC.SFX_EXPLODE);
			FP.world.remove(this);
		}
		override public function update():void 
		{
			
			var t:Bullet =  collide("pbullet", x, y + 1) as Bullet;
			if (t)
			{
				OnExplode();
			}
		
			if (shootTimer != 0 && shootTimer < getTimer() && IsOnScreen())
			{
				shootTimer = getTimer() + 3000;
				
				var ent:Bullet = new Bullet;
				ent.x = x;
				ent.y = y;
				FP.world.add(ent);
				ent.SetAim(Player.getPlayer.x, Player.getPlayer.y + (-10 + Math.random()*20));
				trace("Fire");
			}
		}
		
	}

}